<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<event category="STEP" id="0">
  <actions>
    <action id="603" library="1">
      <!--action name: Code-->
      <kind>CODE</kind>
      <allowRelative>false</allowRelative>
      <question>false</question>
      <canApplyTo>true</canApplyTo>
      <actionType>CODE</actionType>
      <functionName/>
      <relative>false</relative>
      <not>false</not>
      <appliesTo>.self</appliesTo>
      <arguments>
        <argument kind="STRING">
// YASM 1.7 - not using step event inherited from oTreasure
// to prevent issues with gold nugget/chunk performance issues in CoG
if (state == ACTIVE and isNotFrozenX()) {
  if (global.hasSpectacles or global.hasUdjatEye) depth = 0; else depth = 101;

  colLeft = false;
  colRight = false;
  colBot = false;
  if (isCollisionLeft(1)) colLeft = true;
  if (isCollisionRight(1)) colRight = true;
  if (isCollisionBottom(1)) colBot = true;

  moveTo(xVel, yVel);

  if (not colBot) yVel += myGrav;
  if (yVel &gt; 8) yVel = 8;

  /*
  if (isCollisionTop(1)) {
    if (yVel &lt; 0) yVel = -yVel * 0.8; else y += 1;
  }
  */
  if (isCollisionTop(1)) {
    if (yVel &lt; 0) {
      yVel = -yVel * 0.8;
    } else if (colBot) {
      y -= 1;
      depth = 101;
    } else {
      y += 1;
    }
  }

  if (colLeft or colRight) xVel = -xVel * 0.5;

  if (colBot) {
    /*
    // bounce
    if (yVel &gt; 1) yVel = -yVel * 0.5; else yVel = 0;
    */
    // friction
    if (abs(xVel) &lt; 0.1) xVel = 0; else if (abs(xVel) != 0) xVel *= 0.3;
    y -= 1;
    if (not isCollisionBottom(1)) {
      y += 1;
      //state = STATIC;
    }
    yVel = 0;
  }
  // else state = STATIC;

  if (colLeft) {
    if (not colRight) x += 1;
    //yVel = 0;
  } else if (colRight) {
    x -= 1;
    //yVel = 0;
  }

  if (collision_rectangle(x-3, y-3, x+3, y+3, oLava, 0, 0)) {
    myGrav = 0;
    xVel = 0;
    yVel = 0;
    y += 0.05;
  } else {
    myGrav = 0.6;
  }

  if (collision_point(x, y-5, oLava, 0, 0)) instance_destroy();
}
</argument>
      </arguments>
    </action>
  </actions>
</event>
